--[[
MO:
Fix crafters might be added to the list twice with /wcc
Add purging
•gem by color
Tracking of how many people of what crafts there are
List Who Crafts' features over CG in readme
Add !new/!up/!update/!version to tell the user what is new, for their end
prices of mats with auc+fiz cost addon
links of everything, interface with !link and a link addon
Fix !next for !trade
Change storying of 'known by'; make it a table, perhaps, with the var the name and .. them togeather in /wcc. This can then be used to remove duplicates and make it eaiser to use the future import text from /wcp
Added help messages to /wcp
When using /wcs, the user is more informed about what is hapning
Improved error and help messages
Manage !link from LinkBot; merge LB into WC; make it not just for craft links, but other links as well.

•Enscribe who knows a craft on the tooltip, try LibExtraTip
•Blacklist/whitlist of who is allowed to search
•When using /wcs, also msg the person the search term
•Have people whisper '!up <note name> <msg>' and add that to the search list under the whisper's name.
• When using /wcs, the user is more informed about what is hapning
• Improved error and help messages
Add a ChatFrame function
• Added support for searching for items used by an item or that makes an item
Explore CTL; do we need to embed?
!kingme, !bid, !sb to ignore
GUI to search with
Make the whisper back of "I do not know that skill' once per session
Add an options on what names to show/hide
Make the names stored in a table with the index of the name, add names to string when called to print
Upgrade from v1 of the db to v2 with this change
Settings for max total replies for the current whisper target/msg only

TODO:
?if skillType ~= "header" and skillName then --and not searchForBop(GetTradeSkillItemStats(i)) then--NOTE: Fix the commented out two work with all craft/tradeskill windows
?change search terms
add 'purge all' that cleans out the elements that have links
purging of indv. names/crafts/items
check if any in a search return are online or not
remove wording of CG
add a way to toggle DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg) and other search msgs
slash settings for: hide/show whisperes. (player.." searched Who Crafts with: "..msg)
save the trade links, searchable by '!wc person NAME'
add '!wc <search>' that would look up all the trade skills
Add note at begining "Who Crafts by MikeNGo: Whisper a craft to search"
Hide whispers of craftables
Notes per craft, IE elixir/potion/xmute, per name
Notes per 'storefront'; each person whispers "!set <keyword> <text>
Sending notes if more then one lines worth of chars
local search w/o whispers
Eaiser to add crafts to the list; right click on msg with tradeskill link and add it?
Tracking if online, send addon whisper to people as queried, and tell if online and zone, look at WIM
?Add a msg func
Use right kind of cash
Add queue to slow msgs spam
Note cosmetic problems when used with a chat mod, like WIM
GUI to set settings (what channels to lisen to)
A check and warning to disable CG if installed
Fix !help
add slash and search term for cashing the tradeskill link
Manual syncing with other people that have this addon
Lockbox/smelting/herb etc support
Add sounds for cash, etc
Cash chat that has trade links in it, so one can latter go back and update it
Last update log; who, date/time, craft
Requested log; who, date, time, query
Settings via whisper 
Requested updates when xitem is in log to be whispered
For CDs of the crafter-player, add to xmutes, etc., when they are up
Whisper search with iLink
Update search notification with number of results
Tracking of how many people of what crafts there are
When a recipe/pattern is linked, search the name of the pattern not 'formula' or scroll

]]

local _G = _G
local fnd = _G.string.find
local lower = _G.string.lower
local gsub = _G.string.gsub
local sub = _G.string.sub
local rep = _G.strreplace
local tostr = _G.tostring
local tonum = _G.tonumber


local function pr(msg)
	ChatFrame1:AddMessage(msg,.1,.7,.7)
end



-----------------------------------------------------------------------
-- Locale
--
local toFrame = ""
local l = GetLocale()
local FIRST_TELL = "To use Trade Secretary: Who Crafts (v 0.1.07), whisper me \'!craft item\' to search for an item, \'!trade searchterm\' to get trade links and names of crafters, \'!wc\' for the list of other triggers, or \'!help\' for usage information."
local TOO_MANY = "Too many results, %d not shown. Whisper me !next to get more."
local PREFIX = "wc: "
local NOTE = "%s: %s."
local CG_USAGE = "Whisper me '!%s <anything>' to search."
local NO_DATA = "No results found for %q."
local NO_SKILL = "I don't know anyone with this skill. Accepted commands are %s."
local ACCEPTED = "Accepted commands are %s."
local HELP = {
	"Who Crafts accepts various !<skill> commands in whispers or guild chat based on what trade skills the player has available.",
	"Usage: !command <token1> <token2> ...",
	"Each token is matched against all the text that is present in all the recipe tooltips available to this player.",
	"Only tooltips that contain all the given tokens are returned as results to you.",
}
local MENU_HELP = "|cff00ff00Who Crafts|r: |cffeda55fDouble-Click|r a tradeskill or craft item line in order to edit its Who Crafts settings."
local POPUP_TEXT = "|cff00ff00Who Crafts|r\n\nSet a note for %s. The note will be appended after the recipe link in search results sent to players who query you."
local IGNORED = " |cff990000(ignored)|r"

-- Menu locale strings
local MENU = {
	NOTE = "Set note",
	NOTE_DESC = "Sets a note for the current item. The note will be displayed after the recipe link in search results.",
	IGNORE = "Ignore",
	IGNORE_DESC = "Toggle whether or not to ignore this item.",
}

-----------------------------------------------------------------------
-- Tooltip scanner, mostly stolen from Gratuity.
--

local scanItem
do
	local scanner = CreateFrame("GameTooltip")
	scanner:SetOwner(WorldFrame, "ANCHOR_NONE")
	local lcache, rcache = {}, {}
	for i = 1, 30 do
		lcache[i], rcache[i] = scanner:CreateFontString(), scanner:CreateFontString()
		lcache[i]:SetFontObject(GameFontNormal); rcache[i]:SetFontObject(GameFontNormal)
		scanner:AddFontStrings(lcache[i], rcache[i])
	end
	local function erase()
		for i = 1, scanner:NumLines() do rcache[i]:SetText() end
		scanner:ClearLines()
	end
	local scannerCache = {}
	function scanItem(itemLink)
		local linkC = select(3, itemLink:find("|%x+|H.+|h%[(.+)%]|h|r"))
		if linkC then
			erase()
			scanner:SetHyperlink(itemLink)
			for k in pairs(scannerCache) do scannerCache[k] = nil end
			for i = 1, scanner:NumLines() do
				local left, right = lcache[i]:GetText(), rcache[i]:GetText()
				if left then table.insert(scannerCache, left) end
				if right then table.insert(scannerCache, right) end
			end
			return table.concat(scannerCache)
		else
			for k in pairs(scannerCache) do scannerCache[k] = nil end
			table.insert(scannerCache, itemLink)
			return table.concat(scannerCache)
		end
	end
end

-----------------------------------------------------------------------
-- CraftyGnome
--

local fa = GetLocale() == "frFR" and "Premiers soins" or GetSpellInfo(746)

local bangMappings = {
	alchemy = (GetSpellInfo(2259)),
	blacksmith = (GetSpellInfo(2018)),
	cooking = (GetSpellInfo(2550)),
	leather = (GetSpellInfo(2108)),
	enchanting = (GetSpellInfo(7411)),
	engineering = (GetSpellInfo(4036)),
	firstaid = fa,
	jewel = (GetSpellInfo(25229)),
	tailor = (GetSpellInfo(3908)),
	inscription = (GetSpellInfo(45357)),
}
--bangMappings.all = bangMappings
bangMappings.alc = bangMappings.alchemy
bangMappings["in"] = bangMappings.inscription
bangMappings.bs = bangMappings.blacksmith
bangMappings.cook = bangMappings.cooking
bangMappings.lw = bangMappings.leather
bangMappings.enchant = bangMappings.enchanting
bangMappings.eng = bangMappings.engineering
bangMappings.aid = bangMappings.firstaid
bangMappings.jc = bangMappings.jewel
bangMappings.gem = bangMappings.jewel
bangMappings.tailoring = bangMappings.tailor
--bangMappings.craft = true

bangMappings.wc = true
--bangMappings.whocrafts = true
--bangMappings.wcsearch = true
bangMappings.next = true
bangMappings.help = true
bangMappings.craft = "craft"
bangMappings.crafts = true
bangMappings.trade = "trade"

local MAX_RESULTS = 5

local db = {}
local ignoreDB = {}
local notesDB = {}

local bop = ITEM_BIND_ON_PICKUP
local cache = {}
local acceptedCommands = {}
local addon = CreateFrame("Frame")
local _G = _G

--------------------------------------------------------------------------------
-- Right-click menu for craft/tradeskill UI
--

local function forceUpdate()
	if TradeSkillFrame and TradeSkillFrame:IsVisible() then TradeSkillFrame_Update() end
	if CraftFrame and CraftFrame:IsVisible() then CraftFrame_Update() end
end

local currentItem = nil

local function isIgnored(item)
	return ignoreDB[item or currentItem]
end
local function toggleIgnored()
	ignoreDB[currentItem] = not ignoreDB[currentItem]
	forceUpdate()
end

local function getNote(item)
	if db["craft"][item] then
		return ("Known by: "..((db["craft"][item or currentItem][4] ) or "")) or ""
	elseif db["trade"][item] then
		--DEFAULT_CHAT_FRAME:AddMessage("elseif db[trade][item] then")
		return (((" "..(db["trade"][item]) ) or "")) or ""
	end
end
local function getFrameNote(item)
	if db["craft"][item] then
		return ("Known by: "..((db["craft"][item or currentItem][4] ) or "")) or ""
	elseif db["trade"][item] then
		--DEFAULT_CHAT_FRAME:AddMessage("elseif db[trade][item] then")
		return (((" "..(db["trade"][item or currentItem]) ) or "")) or ""
	end
end


local function setNote(item, note)
	if type(note) ~= "string" or note:trim():len() < 2 then note = nil end
	notesDB[item or currentItem] = note
	forceUpdate()
end
local function showNotePopup()
	StaticPopupDialogs["WhoCraftsNote"].text = POPUP_TEXT:format(currentItem)
	StaticPopup_Show("WhoCraftsNote")
end
local function showFramePopup()
	StaticPopupDialogs["WhoCraftsFrame"].text = "Copy the text below with your copy command\n(command and c on mac or control c on Windows)\nand paste to a file or your form or website."--POPUP_TEXT:format(currentItem)
	StaticPopup_Show("WhoCraftsFrame")
end

local menu = {{
	text = MENU.NOTE,
	tooltipTitle = MENU.NOTE,
	tooltipText = MENU.NOTE_DESC,
	func = showNotePopup,
},{
	text = MENU.IGNORE,
	tooltipTitle = MENU.IGNORE,
	tooltipText = MENU.IGNORE_DESC,
	func = toggleIgnored,
	checked = isIgnored,
},}

local popupFrame = CreateFrame("Frame", "WhoCraftsMenu", addon, "UIDropDownMenuTemplate")
local function openMenu(frame, recipe)
	StaticPopup_Hide("WhoCraftsNote")
	currentItem = recipe
	EasyMenu(menu, popupFrame, frame, 20, 4, "MENU")
end

local function onTradeSkillDoubleClick()
	local recipe = GetTradeSkillRecipeLink(this:GetID())
	if recipe then openMenu(this, recipe) end
end
local function onCraftDoubleClick()
	local recipe = GetCraftRecipeLink(this:GetID())
	if recipe then openMenu(this, recipe) end
end

local recursive = nil
local function updateSkillLine(line, text, recipe)
	local note = getNote(recipe)
	local ignored = isIgnored(recipe)
	local append = nil
	if note then append = " - " .. note end
	if ignored then append = (append or "") .. IGNORED end
	if append then
		recursive = true
		line:SetText(text .. append)
	end
end
local function onTradeSkillLineSet(this, text)
	if recursive then recursive = nil; return end
	local recipe = GetTradeSkillRecipeLink(this:GetID())
	if recipe then updateSkillLine(this, text, recipe) end
end
local function onCraftLineSet(this, text)
	if recursive then recursive = nil; return end
	local recipe = GetCraftRecipeLink(this:GetID())
	if recipe then updateSkillLine(this, text, recipe) end
end

function addon:ADDON_LOADED(name)
	if name == "Blizzard_TradeSkillUI" then
		for i = 1, 8 do
			--[[local button = _G["TradeSkillSkill" .. i]
			button:SetScript("OnDoubleClick", onTradeSkillDoubleClick)
			hooksecurefunc(button, "SetText", onTradeSkillLineSet)]]
		end
		--DEFAULT_CHAT_FRAME:AddMessage(MENU_HELP)
	elseif name == "Blizzard_CraftUI" then
		for i = 1, 8 do
			--[[local button = _G["Craft" .. i]
			button:SetScript("OnDoubleClick", onCraftDoubleClick)
			hooksecurefunc(button, "SetText", onCraftLineSet)]]
		end
		--DEFAULT_CHAT_FRAME:AddMessage(MENU_HELP)
	end
end

--------------------------------------------------------------------------------
-- Craft/tradeskill scanning
--

-- XXX we should just save the spell ID in the database like I did originally,
-- XXX maybe we can use GetSpellLink and GetSpellInfo on the recipe IDs in 2.4
-- XXX in any case, we can just create the links manually from the ID like
-- XXX |cffffd000|Henchant:"..recipeId.."|h[Placeholder Name]|h|r"
-- XXX and then use tooltip:SetHyperlink
-- XXX if we do this we also have to get the name and from the tooltip so we can
-- XXX construct the recipe link properly when someone wants a link


SLASH_WHOCRAFTS_INSTRUCT1 = "/wcinstruct"
SLASH_WHOCRAFTS_INSTRUCT2 = "/wci"
SlashCmdList["WHOCRAFTS_INSTRUCT"] = function( msg )
	if msg then 
		SendChatMessage(PREFIX .. "Please whisper me \'!craft <item name>\' to try my AddOn, Trade Secretary: Who Crafts. It can help you find who can craft an item you want made. Also, you can message me through guild or party chat. Whisper me your profession links to add them.", "WHISPER", nil, msg) 
		DEFAULT_CHAT_FRAME:AddMessage("Sent "..msg.." Who Crafts instructions.")
	end
	
end


SLASH_WHOCRAFTS_CASH1 = "/wccash"
SLASH_WHOCRAFTS_CASH2 = "/wcc"
SLASH_WHOCRAFTS_CASH3 = "/whocraftscash"
SlashCmdList["WHOCRAFTS_CASH"] = function( msg )
	--Format, with the trade window open: /wcc CRAFTER_NAME [SHIFT_CLICKED_LINK] NOTES
	if not msg or msg == "" then 
		DEFAULT_CHAT_FRAME:AddMessage("No name defined") 
		DEFAULT_CHAT_FRAME:AddMessage("Format: /wcc PERSON_NAME LINK_OF_CRAFT")
		return 
	else
		local _,_,oldpname = string.find(msg, "^(%S+)")
		local tLink, name
		local hasWindow = false
		if oldpname  then
		
			--DEFAULT_CHAT_FRAME:AddMessage("before :"..pname)
			local _,_,pnamefirst = string.find(oldpname, "^(.)")
			--DEFAULT_CHAT_FRAME:AddMessage("fir :"..pnamefirst)
			local _,_,pnamelast = string.find(oldpname, pnamefirst.."(.*)$")
			--DEFAULT_CHAT_FRAME:AddMessage("last :"..pnamelast)
			pname = string.upper(pnamefirst)..string.lower(pnamelast)
			
			--DEFAULT_CHAT_FRAME:AddMessage("after :"..pname)
			--DEFAULT_CHAT_FRAME:AddMessage("pname :"..pname)
			--[[local pnamelower = string.lower(pname)
			local pnamefirst = string.sub(pnamelower,1,1)
			pnamefirst = string.upper(pnamefirst)
			local pnamelast = string.sub(pname,2,string.len(pnamelast))
			pname = pnamefirst..pnaamelast]]
			
			name, level = GetTradeSkillLine()
			if name == "UNKNOWN" then 
				--No craft window open
				--return 
			else
				hasWindow = true
			end
			
			if not db["craft"] then db["craft"] = {} end
			if not db["trade"] then db["trade"] = {} end
			local note, prof
			local tLink = select(3, msg:find("^"..pnamefirst..pnamelast.."%s+(|%x+|H.+|h%[.+%]|h|r)"))
			if tLink then
				note = select(3, msg:find("^"..pnamefirst..pnamelast.."%s+|%x+|H.+|h%[.+%]|h|r%s(.*)"))
			else
				name = select(3, msg:find("^"..pnamefirst..pnamelast.."%s+%[(.+)%]"))
				if name then
					note = select(3, msg:find("^"..pnamefirst..pnamelast.."%s+%[.+%]%s(.*)"))
				else
					DEFAULT_CHAT_FRAME:AddMessage("No craft link inputted.")
					DEFAULT_CHAT_FRAME:AddMessage("Format: /wcc PERSON_NAME LINK_OF_CRAFT")
					return--no second arg
				end
			end
			if not note then note = "" end

			local updated
			do
				local _, dateMonth, dateDay, dateYear = CalendarGetDate() 
				updated = ". Last updated: "..dateMonth.."-"..dateDay.."-"..dateYear..". "
			end
			
			local checks
			--tLink = GetTradeSkillListLink()--
			if name ~= "UNKNOWN" then 
				if tLink then
					--	currentRecipe = gsub(string.format ('%q', link) or "", "\124", "\124\124");	
	
					db["trade"][pname.."\'s "..name] = pname.."'s "..level.." "..tLink..updated..note
				else
					db["trade"][pname.."\'s "..name] = pname.."'s "..name..updated..note
					--[[if not db["trade"][pname.."\'s "..name] then
						db["trade"][pname.."\'s "..name] = pname.."'s "..name..updated..note
					else
						checks = select(3, db["trade"][pname.."\'s "..name]:find("(|%x+|H.+|h%[.+%]|h|r)"))
						if not checks then
							db["trade"][pname.."\'s "..name] = pname.."'s "..name..updated..note
						end
						DEFAULT_CHAT_FRAME:AddMessage(checks)
					end]]
				end
			end
			
			if hasWindow then
				if not db[name] then db[name] = {} end
				for i = 1, GetNumTradeSkills() do
					local skillName, skillType = GetTradeSkillInfo(i)
					if skillType ~= "header" and skillName then --and not searchForBop(GetTradeSkillItemStats(i)) then--NOTE: Fix the commented out two work with all craft/tradeskill windows
						local link = GetTradeSkillItemLink(i)
						local recipe = GetTradeSkillRecipeLink(i)
						if link and recipe and not isIgnored(recipe) then
						
							local _, _, _, level = GetItemInfo(link)
							local l = level or 1
							--if not db[name][recipe] or db[name][recipe] < l then
							--[[if not db[recipe] then
								db[recipe] = {}
							end]]
							local i,v,recipeName = string.find(recipe, "|c%x-|H.-|h%[(.-)%]")
							if db[name][recipe] then
								local i,v,currentName = string.find(db[name][recipe][4], "%f[%a]("..pname..")%f[%A]")--		 "%f[%a]lockpick%f[%A]",
	
								if not currentName then
									db[name][recipe][4] = pname..", "..db[name][recipe][4]
									db["craft"][recipe][4] = pname..", "..db[name][recipe][4]
									--setNote(recipe, db[name][recipe][4])
								end
							else
								
								db[name][recipe] = {}
								db[name][recipe][1] = l
								db[name][recipe][2] = recipeName
								db[name][recipe][3] = recipe
								db[name][recipe][4] = pname
								db["craft"][recipe] = {}
								db["craft"][recipe][1] = l
								db["craft"][recipe][2] = recipeName
								db["craft"][recipe][3] = recipe
								db["craft"][recipe][4] = pname
								--setNote(recipe, db[name][recipe][4])
							end
							--DEFAULT_CHAT_FRAME:AddMessage("db[recipe][3] :"..db[recipe][3])
						end
					end
				end
				
			end
		DEFAULT_CHAT_FRAME:AddMessage(pname.."'s "..(tLink or name).." appended to Who Crafts list") 
		else
			DEFAULT_CHAT_FRAME:AddMessage("No tradeskill window open.")
		end
	end
	--[[if (not link) or ( link == "") then return end
	StaticPopup_Hide("WhoCraftsNote")
	--local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture = GetItemInfo(link) 
	--DEFAULT_CHAT_FRAME:AddMessage("itemLink: "..(itemLink or ""))
	--local recipe = GetCraftRecipeLink(this:GetID())
	currentRecipe = gsub(string.format ('%q', link) or "", "\124", "\124\124");	
	_,_,currentRecipe = string.find(currentRecipe or "", "^\"(.*)\"$")
	--currentRecipe = gsub(string.format ('%q', currentRecipe) or "", string.format ('%q',"\"\124\""), "\124");	
	currentItem = link or ""
	showNotePopup()]]
end


function addon:CRAFT_SHOW()
	local name = GetCraftName()
	if not name then return end
	if not db[name] then db[name] = {} end
	for i = 1, GetNumCrafts() do
		local skillName, _, skillType, _, _, _, level = GetCraftInfo(i)
		if skillType ~= "header" and skillName then
			local recipe = GetCraftRecipeLink(i)
			if recipe and not isIgnored(recipe) then
				local tooltipContents = scanItem(recipe)
				local l = level or 1
				if not tooltipContents:find(bop) and (not db[name][recipe] or db[name][recipe] < l) then
					db[name][recipe] = l
				end
			end
		end
	end
end

local function searchForBop(...)
	for i = 1, select("#", ...) do
		if select(i, ...) == bop then return true end
	end
end

function addon:TRADE_SKILL_SHOW()
	local name = GetTradeSkillLine()
	if not name then return end
	if not db[name] then db[name] = {} end
	for i = 1, GetNumTradeSkills() do
		local skillName, skillType = GetTradeSkillInfo(i)
		if skillType ~= "header" and skillName and not searchForBop(GetTradeSkillItemStats(i)) then
			local link = GetTradeSkillItemLink(i)
			local recipe = GetTradeSkillRecipeLink(i)
			if link and recipe and not isIgnored(recipe) then
				local _, _, _, level = GetItemInfo(link)
				local l = level or 1
				if not db[name][recipe] or db[name][recipe] < l then
					db[name][recipe] = l
				end
			end
		end
	end
end

--------------------------------------------------------------------------------
-- Query processing
--

do
	local ctl = ChatThrottleLib
	local reply = ctl and
		function(msg, player)  msg = string.sub(msg, 1, 250) ctl:SendChatMessage("BULK", "WhoCrafts", PREFIX .. msg, "WHISPER", nil, player) end or
		function(msg, player) msg = string.sub(msg, 1, 250) SendChatMessage(PREFIX .. msg, "WHISPER", nil, player) end

	local function updateCache(skill)
		if not cache[skill] then cache[skill] = {} end
		for item in pairs(db[skill]) do
			if not cache[skill][item] and not isIgnored(item) then
				cache[skill][item] = scanItem(item):lower()
			end
		end
	end
	local queryType = ""
	--[[local function updateCacheTrade(skill)
		if not cache[skill] then cache[skill] = {} end
		for item in pairs(db[skill]) do
			--if not cache[skill] and not isIgnored(item) then
				table.insert(cache[skill],item:lower())
			--end
		end
	end

	local function count(t) 
		--if not t then DEFAULT_CHAT_FRAME:AddMessage("count() error3") return false end-- comment out to better be able to find an error?
		local foo = 0 
		--add error message i count(t) is nil
		for _ in ipairs(t) do
			foo = foo + 1 
		end 
		return foo
	end ]]

	--[[local function updateCacheNote(skill)
		if not cache then cache = {} end
		for item in pairs(notesDB) do
			if not cache[item] and not isIgnored(item) then
				cache[item] = scanItem(item):lower()
			end
		end
	end]]

	local function updateAcceptedCommands()
		for k in pairs(acceptedCommands) do acceptedCommands[k] = nil end
		for k, v in pairs(bangMappings) do
			if db[v] then
				table.insert(acceptedCommands, "!" .. k)
			end
		end
		--table.insert(acceptedCommands, "!wcsearch")
		--table.insert(acceptedCommands, "!whocrafts")
		table.insert(acceptedCommands, "!wc")
		table.insert(acceptedCommands, "!help")
		--table.insert(acceptedCommands, "!trade")
	end

	local function search(skill, ...)
		local tbl
		if cache[skill] then
			local c = select("#", ...)
			for item, details in pairs(cache[skill]) do
				if not isIgnored(item) then
					local matchAll = true
					for i = 1, c do
						local token = tostring(select(i, ...)):lower()
						if not details:find(token) then
							matchAll = nil
						end
					end
					if matchAll then
						if not tbl then tbl = {} end
						table.insert(tbl, item)
					end
				end
			end
		end
		return tbl
	end
	
	local function searchT(skill, ...)
		local tbl
		if cache[skill] then
			local c = select("#", ...)
			for item, details  in pairs(cache[skill]) do
				if not isIgnored(item) then
					local matchAll = true
					for i = 1, c do
						local token = tostring(select(i, ...)):lower()
						if not details:find(token) then
							matchAll = nil
						end
					end
					if matchAll then
						if not tbl then tbl = {} end--					note = select(3, msg:find("^"..pnamefirst..pnamelast.."%s+%[.+%]%s(.*)"))
						--ChatFrame1:AddMessage("item "..item)
						--ChatFrame1:AddMessage("details "..details)
						--ChatFrame1:AddMessage(string.sub(item,1,select(1, item:find("^.+'s .+:  (.+)$"))))
						table.insert(tbl, db[skill][item])
					end
				end
			end
		end
		return tbl
	end

	--[[local function searchTrade(skill, ...)
		local tbl
		--DEFAULT_CHAT_FRAME:AddMessage("searchTrade()")
		if cache[skill] then
			local c = select("#", ...)
			for item, details in pairs(cache[skill]) do
				--if not isIgnored(item) then
					local matchAll = true
					for i = 1, c do
						local token = tostring(select(i, ...)):lower()
						DEFAULT_CHAT_FRAME:AddMessage("token: "..(token or ""))
						if  item:find(token) then
							if not tbl then tbl = {} end
							table.insert(tbl, item)
							
						end
					end
					if matchAll then
						--if not tbl then tbl = {} end
						--DEFAULT_CHAT_FRAME:AddMessage(item)
						--DEFAULT_CHAT_FRAME:AddMessage(details)
						--table.insert(tbl, details)
					end
				--end
			end
		end
		return tbl
	end]]

	local function replyWithNote(item, player)
		local note = getNote(item)
		if note then
			reply(NOTE:format(item, note), player)
		else
			reply(item, player)
		end
	end

	local function replyWithNoteF(item, player)
		local note = getNote(item)
		if note then
			--reply(NOTE:format(item, note), player)
		else
			--reply(item, player)
		end
	end

	local function replyWithNoteTrade(item, player)
		local note = getNote(item)
		if note then
			reply(NOTE:format(item, note), player)
		else
			reply(item, player)
		end
	end

	local moreResults = {}

	local function replyResults(tbl, player)
		if not tbl then return end
		if #tbl > MAX_RESULTS then
			for i = 1, MAX_RESULTS do				
				if tbl[i] then replyWithNote(tbl[i], player) end
			end
			for i = 1, MAX_RESULTS do table.remove(tbl, 1) end
			reply(TOO_MANY:format(#tbl), player)
		else
			for i, v in ipairs(tbl) do replyWithNote(v, player) end
			--ChatFrame1:AddMessage("i "..i)
			--ChatFrame1:AddMessage("v "..v)
			tbl = nil
		end
		return tbl
	end

	local function replyResultsSize(tbl, player)
		if not tbl then return end
		return #tbl
	end

	local bangHandlers = {}
	bangHandlers.next = function(player)
		--DEFAULT_CHAT_FRAME:AddMessage(player.."0 searched Who Crafts with: !next. "..(#(moreResults[player] or {}) or "0").." results returned." )	
		moreResults[player] = replyResults(moreResults[player], player)		
	end
	bangHandlers.crafts = function(player)
		updateAcceptedCommands()
		reply(ACCEPTED:format(table.concat(acceptedCommands, ", ")), player)
	end
	--bangHandlers.trade = function(player)
		--updateAcceptedCommands()
		--reply(ACCEPTED:format(table.concat(acceptedCommands, ", ")), player)
	--end
	bangHandlers.wc = bangHandlers.crafts
	bangHandlers.help = function(player, isWhisper)
		if not isWhisper then return end
		for i, v in pairs(HELP) do
			reply(v, player)
		end
		bangHandlers.crafts(msg, player)
	end

	local skillSorters = {}
	local hasPlayerSession = {}
	local currentResults
	local function processChat(msg, player, isWhisper)
		--DEFAULT_CHAT_FRAME:AddMessage("msg: "..(msg or ""))
		local cmd = select(3, msg:find("^!(%S+)"))
		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		if cmd then 
			if cmd == "link" then return end
			if not hasPlayerSession[player] then
				reply(FIRST_TELL, player)
				hasPlayerSession[player] = true
			end
			cmd = cmd:lower() 
			if not cmd or not bangMappings[cmd] then if isWhisper then updateAcceptedCommands() reply(NO_SKILL:format(table.concat(acceptedCommands, ", ")), player) end return end
			if bangHandlers[cmd] then
				bangHandlers[cmd](player, isWhisper)
				if cmd == "next" then --or cmd == "trade" then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(moreResults[player] or {}) or "0").." results returned." )	
				end
				return
			end
		else

			return
		end
		local nag = true
		local results
		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		local query = select(3, msg:find("^!%S+%s(.*)"))
		local linkC = select(3, msg:find("|%x+|H.+|h%[(.+)%]|h|r"))
		if linkC then
			query = linkC
		end
		if query then
			--DEFAULT_CHAT_FRAME:AddMessage("query: "..(query or ""))
			local skill = bangMappings[cmd]
			--if not skill then
			--	skill = notesDB[item or currentItem]
			--end
			if db[skill] then
				updateCache(skill)

				local name = GetItemInfo(query)
				if name then
					-- This is an item, don't split it up into multiple tokens
					if cmd == "trade" then
						results = searchT(skill, query)
						if not currentResults then
							currentResults = results
						end
					else
						results = search(skill, query)
						if not currentResults then
							currentResults = results
						end
					end
					--DEFAULT_CHAT_FRAME:AddMessage("488")
				else
					--DEFAULT_CHAT_FRAME:AddMessage("290")
					if cmd == "trade" then
						results = searchT(skill, strsplit(" ", query))
						if not currentResults then
							currentResults = results
						end
					else
						results = search(skill, strsplit(" ", query))
						if not currentResults then
							currentResults = results
						end
					end
				end
				if results then
					if queryType == "wcs" then
						reply("The query  >"..msg.."<  has been sent to you.", player)
					end
					
					--DEFAULT_CHAT_FRAME:AddMessage("Count() :"..(#results or "0"))
					if cmd == trade then
						if not skillSorters[skill]  then
							skillSorters[skill] = function(a, b)
								return db[skill][a] > db[skill][b]
							end
						end
					
					else
						if not skillSorters[skill]  then
							if  cmd ~= "trade" then
								skillSorters[skill] = function(a, b)
									return db[skill][a][1] > db[skill][b][1]
								end
							end
						end
					end
					table.sort(results, skillSorters[skill])
					moreResults[player] = replyResults(results, player)
				elseif isWhisper then
					reply(NO_DATA:format(query), player)
				end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(currentResults or {}) or "0").." results returned." )
					currentResults = nil
					nag = false
				end
			else
				updateAcceptedCommands()
				if not cmd == "craft" then
					reply(NO_SKILL:format(table.concat(acceptedCommands, ", ")), player)
				end
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(currentResults or {}) or "0").." results returned." )
					currentResults = nil
					nag = false
				end
		elseif isWhisper then
			--DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg)
			if cmd then
				reply(CG_USAGE:format(cmd), player)
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(currentResults or {}) or "0").." results returned." )
					currentResults = nil
					nag = false
				end
		end
	end
	
	
	local function printF(msg, player, isWhisper)
		
		--DEFAULT_CHAT_FRAME:AddMessage("msg: "..(msg or ""))
		if not msg then
			DEFAULT_CHAT_FRAME:AddMessage("No argument 'msg' to printF()")
			return
		end
		if not player then
			DEFAULT_CHAT_FRAME:AddMessage("No argument 'player' to printF()")
			return
		end
		local cmd = select(3, msg:find("^!(%S+)"))
		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		if cmd then 
			--if not hasPlayerSession[player] then
				--reply(FIRST_TELL, player)
				--hasPlayerSession[player] = true
			--end
			cmd = cmd:lower() 
			if not cmd or not bangMappings[cmd] then if isWhisper then updateAcceptedCommands() reply(NO_SKILL:format(table.concat(acceptedCommands, ", ")), player) end return end
			if bangHandlers[cmd] then
				bangHandlers[cmd](player, isWhisper)
				if cmd == "next" then --or cmd == "trade" then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(moreResults[player] or {}) or "0").." results returned." )	
				end
				return
			end
		else

			return
		end
		if  cmd == "trade" then
			DEFAULT_CHAT_FRAME:AddMessage("Printing of 'trade' is not allowed.")
			return
		end
		local nag = true
		local results
		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		local query = select(3, msg:find("^!%S+%s(.*)"))
		local linkC = select(3, msg:find("|%x+|H.+|h%[(.+)%]|h|r"))
		if linkC then
			query = linkC
		end
		if query then
			--DEFAULT_CHAT_FRAME:AddMessage("query: "..(query or ""))
			local skill = bangMappings[cmd]
			--if not skill then
			--	skill = notesDB[item or currentItem]
			--end
			if db[skill] then
				updateCache(skill)

				local name = GetItemInfo(query)
				if name then
					-- This is an item, don't split it up into multiple tokens
					if cmd == "trade" then
						results = searchT(skill, query)
					else
						results = search(skill, query)
					end
					--DEFAULT_CHAT_FRAME:AddMessage("488")
				else
					--DEFAULT_CHAT_FRAME:AddMessage("290")
					if cmd == "trade" then
						results = searchT(skill, strsplit(" ", query))
					else
						results = search(skill, strsplit(" ", query))
					end
				end
				if results then
					--DEFAULT_CHAT_FRAME:AddMessage("Count() :"..(#results or "0"))
					if cmd == trade then
						if not skillSorters[skill]  then
							skillSorters[skill] = function(a, b)
								return db[skill][a] > db[skill][b]
							end
						end
					
					else
						if not skillSorters[skill]  then
							if  cmd ~= "trade" then
								skillSorters[skill] = function(a, b)
									return db[skill][a][1] > db[skill][b][1]
								end
							end
						end
					end
					local fString = ""
					table.sort(results, skillSorters[skill])
					--moreResults[player] = replyResults(results, player)
					for i=1,#results do
						local url1 = ""
						local url2 = ""
						local id2 = ""
						local itemName = select(3, results[i]:find("|%x+|H%a-:[^:]+:?.*|h%[(.+)%]|h|r"))
						local enchantID = select(3, results[i]:find("|%x+|H(%a-:[^:]+:?.*)|h%[.+%]|h|r"))
						local prefix = select(3, enchantID:find("(%a-):[^:]+:?.*"))
						local id = select(3, enchantID:find("%a-:([^:]+):?.*"))
						--DEFAULT_CHAT_FRAME:AddMessage("\n\nitemName: "..(itemName or ""))
						--DEFAULT_CHAT_FRAME:AddMessage("enchantID: "..(enchantID or ""))
						if prefix == "enchant" then
							url1 = "http://www.wowhead.com/?spell="..id
							--AllianceScore = tonumber(string.sub(tonumber(AllianceScore,21,string.find(AllianceScore,"/")) - 1));
							--itemName = string.sub(itemName,(string.find(itemName,":"))+1)
							--itemName = select(3, itemName:find(".-: (.+)"))
							--[[DEFAULT_CHAT_FRAME:AddMessage("itemName: "..(itemName or ""))
							if GetItemInfo(itemName) then
								DEFAULT_CHAT_FRAME:AddMessage("GetItemInfo(itemName): true")
							else
								DEFAULT_CHAT_FRAME:AddMessage("GetItemInfo(itemName): false")						
							end
							_,id2 = GetItemInfo(itemName)
							DEFAULT_CHAT_FRAME:AddMessage("id2: "..(id2 or ""))
							url2 = "http://www.wowhead.com/?item="..id2]]
							fString = fString..(itemName.." "..(url1 or "").." "..(url2 or "").." "..getFrameNote(results[i]).."\n\n" or "")
						else
							fString = fString..((itemName or "").." "..getFrameNote(results[i]).."\n\n" or "")
							--DEFAULT_CHAT_FRAME:AddMessage("WhoCrafts error: prefix \"enchant\" not found.")
							--return
						end
						
					end
					toFrame = fString 
					showFramePopup()
				elseif isWhisper then
					--reply(NO_DATA:format(query), player)
				end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
			else
				updateAcceptedCommands()
				if not cmd == "craft" then
					ChatFrame1:AddMessage(NO_SKILL:format(table.concat(acceptedCommands, ", ")))
				end
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
		elseif isWhisper then
			DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg)
			if cmd then
				ChatFrame1:AddMessage(CG_USAGE:format(cmd))
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
		end
	end



	 function printTT(msg, player, isWhisper)
		--DEFAULT_CHAT_FRAME:AddMessage("msg: "..(msg or ""))
		if not msg then
			DEFAULT_CHAT_FRAME:AddMessage("No argument 'msg' to printF()")
			return
		end
		if not player then
			--DEFAULT_CHAT_FRAME:AddMessage("No argument 'player' to printF()")
			--return
		end
		local cmd = select(3, msg:find("^!(%S+)"))
		--cmd = 'craft'

		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		if cmd then 
			--if not hasPlayerSession[player] then
				--reply(FIRST_TELL, player)
				--hasPlayerSession[player] = true
			--end
			cmd = cmd:lower() 
			if not cmd or not bangMappings[cmd] then if isWhisper then updateAcceptedCommands() reply(NO_SKILL:format(table.concat(acceptedCommands, ", ")), player) end return end
			if bangHandlers[cmd] then
				bangHandlers[cmd](player, isWhisper)
				if cmd == "next" then --or cmd == "trade" then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(moreResults[player] or {}) or "0").." results returned." )	
				end
				return
			end
		else

			return
		end
		if  cmd == "trade" then
			DEFAULT_CHAT_FRAME:AddMessage("Printing of 'trade' is not allowed.")
			return
		end
		local nag = true
		local results
		--DEFAULT_CHAT_FRAME:AddMessage("cmd: "..(cmd or ""))
		local query = select(3, msg:find("^!%S+%s(.*)"))
		local linkC = select(3, msg:find("|%x+|H.+|h%[(.+)%]|h|r"))
		if linkC then
			query = linkC
		end
		if query then
			--DEFAULT_CHAT_FRAME:AddMessage("query: "..(query or ""))
			local skill = bangMappings[cmd]
			--if not skill then
			--	skill = notesDB[item or currentItem]
			--end
			if db[skill] then
				updateCache(skill)

				local name = GetItemInfo(query)
				if name then
					-- This is an item, don't split it up into multiple tokens
					if cmd == "trade" then
						results = searchT(skill, query)
					else
						results = search(skill, query)
					end
					--DEFAULT_CHAT_FRAME:AddMessage("488")
				else
					--DEFAULT_CHAT_FRAME:AddMessage("290")
					if cmd == "trade" then
						results = searchT(skill, strsplit(" ", query))
					else
						results = search(skill, strsplit(" ", query))
					end
				end
				if results then
					--DEFAULT_CHAT_FRAME:AddMessage("Count() :"..(#results or "0"))
					if cmd == trade then
						if not skillSorters[skill]  then
							skillSorters[skill] = function(a, b)
								return db[skill][a] > db[skill][b]
							end
						end
					
					else
						if not skillSorters[skill]  then
							if  cmd ~= "trade" then
								skillSorters[skill] = function(a, b)
									return db[skill][a][1] > db[skill][b][1]
								end
							end
						end
					end
					local fString = ""
					table.sort(results, skillSorters[skill])
					--moreResults[player] = replyResults(results, player)
					for i=1,1 do
						local url1 = ""
						local url2 = ""
						local id2 = ""
						local itemName = select(3, results[i]:find("|%x+|H%a-:[^:]+:?.*|h%[(.+)%]|h|r"))
						local enchantID = select(3, results[i]:find("|%x+|H(%a-:[^:]+:?.*)|h%[.+%]|h|r"))
						local prefix = select(3, enchantID:find("(%a-):[^:]+:?.*"))
						local id = select(3, enchantID:find("%a-:([^:]+):?.*"))
						--DEFAULT_CHAT_FRAME:AddMessage("\n\nitemName: "..(itemName or ""))
						--DEFAULT_CHAT_FRAME:AddMessage("enchantID: "..(enchantID or ""))
						if prefix == "enchant" then
							url1 = "http://www.wowhead.com/?spell="..id
							--AllianceScore = tonumber(string.sub(tonumber(AllianceScore,21,string.find(AllianceScore,"/")) - 1));
							--itemName = string.sub(itemName,(string.find(itemName,":"))+1)
							--itemName = select(3, itemName:find(".-: (.+)"))
							--[[DEFAULT_CHAT_FRAME:AddMessage("itemName: "..(itemName or ""))
							if GetItemInfo(itemName) then
								DEFAULT_CHAT_FRAME:AddMessage("GetItemInfo(itemName): true")
							else
								DEFAULT_CHAT_FRAME:AddMessage("GetItemInfo(itemName): false")						
							end
							_,id2 = GetItemInfo(itemName)
							DEFAULT_CHAT_FRAME:AddMessage("id2: "..(id2 or ""))
							url2 = "http://www.wowhead.com/?item="..id2]]
							if player then
								local out
								for i=1,#results do
								
								end
								return
							else
								return getFrameNote(results[i])
							end
						else
							DEFAULT_CHAT_FRAME:AddMessage("WhoCrafts error: prefix \"enchant\" not found.")
							return
						end
						
						--fString = fString..(itemName.." "..(url1 or "").." "..(url2 or "").." "..getFrameNote(results[i]).."\n\n" or "")
					end
					--toFrame = fString 
					--showFramePopup()
				elseif isWhisper then
					--reply(NO_DATA:format(query), player)
				end
				if nag then
					--DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
			else
				updateAcceptedCommands()
				if not cmd == "craft" then
					ChatFrame1:AddMessage(NO_SKILL:format(table.concat(acceptedCommands, ", ")))
				end
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
		elseif isWhisper then
			DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg)
			if cmd then
				ChatFrame1:AddMessage(CG_USAGE:format(cmd))
			end
				if nag then
					DEFAULT_CHAT_FRAME:AddMessage(player.." searched Who Crafts with: "..msg..". "..(#(results or {}) or "0").." results returned." )
					nag = false
				end
		end
	end
	SLASH_WHOCRAFTS_SEARCH1 = "/wcsearch"
	SLASH_WHOCRAFTS_SEARCH2 = "/wcs"
	SLASH_WHOCRAFTS_SEARCH3 = "/whocraftssearch"
	SlashCmdList["WHOCRAFTS_SEARCH"] = function( msg )
		local i,j, target, search = string.find(msg, "^([^ ]+) (!.*)$")
		--ChatFrame1:AddMessage("target: "..(target or "nil"))
		--ChatFrame1:AddMessage("search: "..(search or "nil"))
		if ( not target ) or ( not search ) then
			ChatFrame1:AddMessage("No target or search command\nFormat: /wcs NAME !craft SEARCH")
			return
		end
		queryType = "wcs"
		processChat(search,target)
		queryType = ""
	end
	SLASH_WHOCRAFTS_PRINTF1 = "/printf"
	SLASH_WHOCRAFTS_PRINTF2 = "/wcsp"
	SLASH_WHOCRAFTS_PRINTF3 = "/wcp"
	SlashCmdList["WHOCRAFTS_PRINTF"] = function( msg )
		--local i,j, search = string.find(msg, "^(!.*)$")
		--ChatFrame1:AddMessage("target: "..(target or "nil"))
		--ChatFrame1:AddMessage("search: "..(search or "nil"))
		if ( type(msg) ~= "string" or msg == "" ) then
			ChatFrame1:AddMessage("No search command\nFormat: /wcp !COMMAND SEARCH")
			return
		else
			printF(msg,UnitName("player"))
		end
	end

	function WC_SlashProcessChat(msg, player, isWhisper)
		processChat(msg, player, isWhisper)
	end
	function addon:CHAT_MSG_GUILD(msg, player)
		processChat(msg, player)
	end
	function addon:CHAT_MSG_WHISPER(msg, player)
		processChat(msg, player, true)
	end
	function addon:CHAT_MSG_PARTY(msg, player)
		processChat(msg, player)
	end
	function addon:CHAT_MSG_RAID(msg, player)
		processChat(msg, player)
	end
	function addon:CHAT_MSG_OFFICER(msg, player)
		processChat(msg, player)
	end
	function addon:CHAT_MSG_RAID_LEADER(msg, player)
		processChat(msg, player)
	end
end





--db["craft"][recipe][4] 

--Engravings = {}
--local sources = Engravings
local origs = {}
local R, G, B = 1, 136/255, 0

local function OnTooltipSetItem(frame, ...)
	local name = getglobal("GameTooltipTextLeft"..1)
	name = name:GetText()
	local i,j,full,word = fnd(name,"((.*):.*)")
	local re
	if not full then
		full = name
	end
	if full then 
		--print(name)
		--local sname = GetSpellLink(full)
		--/run print(GetSpellInfo("Cooking: Lynx Steak"))
		--print(sname)
		 re = printTT("!craft "..full)
	--local re = db["craft"]
	--re:find("|%x+|H%a-:[^:]+:?.*|h%[(.+%)]|h|r"))
	end
	--[[if UnitIsPlayer(name) then
		print(name)
		re = printTT("!trade "..full, true)
	end	]]
	--print(re)
	if full then
		if re then
			local str
			for i=1,5 do
				local p1 select(3,re:find("^[%S-] [%S-] [%S-]"))
				if p1 then
					str = p1.."\n"
					re = sub(re,#(p1.."\n"))
				end
			end
			str = re
			frame:AddLine("\n"..re, R, G, B, R, G, B)
			--local id = tonumber(link:match("item:(%d+):"))
			--for title,data in pairs(sources) do if data[id] then frame:AddDoubleLine(type(title) == "string" and title or "", data[id], R, G, B, R, G, B) end end
		end
	end
	if origs[frame] then return origs[frame](frame, ...) end
end


for _,frame in pairs{GameTooltip, ItemRefTooltip, ShoppingTooltip1, ShoppingTooltip2} do
	origs[frame] = frame:GetScript("OnTooltipSetItem")
	frame:SetScript("OnTooltipSetItem", OnTooltipSetItem)
end


--------------------------------------------------------------------------------
-- Core addon and event handling
--

function addon:PLAYER_ENTERING_WORLD()
	if not WhoCraftsDB then WhoCraftsDB = {} end
	local realm = GetRealmName()
	if not WhoCraftsDB[realm] then WhoCraftsDB[realm] = {} end
	local faction = UnitFactionGroup("player")
	if not WhoCraftsDB[realm][faction] then WhoCraftsDB[realm][faction] = {} end
	db = WhoCraftsDB[realm][faction]

	if not db.version or db.version < 1 then
		for k in pairs(db) do db[k] = nil end
		db.version = 1
	end

	if not WhoCraftsDB.ignoredItems then WhoCraftsDB.ignoredItems = {} end
	ignoreDB = WhoCraftsDB.ignoredItems

	if not WhoCraftsDB.notes then WhoCraftsDB.notes = {} end
	notesDB = WhoCraftsDB.notes

	StaticPopupDialogs["WhoCraftsNote"] = {
		text = nil,
		button1 = MENU.NOTE,
		button2 = CANCEL,
		whileDead = 1,
		hideOnEscape = 1,
		timeout = 0,
		OnShow = function()
			-- We have to do this onshow to reset the previous text
			_G[this:GetName().."EditBox"]:SetText(getNote(currentItem) or "")
		end,
		OnHide = function()
			_G[this:GetName().."EditBox"]:SetText("")
		end,
		EditBoxOnEnterPressed = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			setNote(currentItem, t)
			this:GetParent():Hide()
		end,
		EditBoxOnEscapePressed = function()
			this:GetParent():Hide()
		end,
		OnAccept = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			setNote(currentItem, t)
		end,
		hasEditBox = 1,
	}
	StaticPopupDialogs["WhoCraftsFrame"] = {
		text = nil,
		--button1 = MENU.NOTE,
		button2 = CANCEL,
		whileDead = 1,
		hideOnEscape = 1,
		timeout = 0,
		ignoreArrows = true,
		OnShow = function()
			-- We have to do this onshow to reset the previous text
			_G[this:GetName().."EditBox"]:SetText(toFrame or "")
			_G[this:GetName().."EditBox"]:HighlightText()
			toFrame = ""
		end,
		OnHide = function()
			_G[this:GetName().."EditBox"]:SetText("")
		end,
		EditBoxOnEnterPressed = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			--setNote(currentItem, t)
			this:GetParent():Hide()
		end,
		EditBoxOnEscapePressed = function()
			this:GetParent():Hide()
		end,
		OnAccept = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			--setNote(currentItem, t)
		end,
		hasEditBox = 1,
	}

	addon:UnregisterEvent("PLAYER_ENTERING_WORLD")
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", function(msg)
	local cmd = select(3, msg:find("^!(%S+)"))
	if cmd and bangMappings[cmd:lower()] then return true end
end)
local chatPrefixTest = "^" .. PREFIX
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(msg)
	if msg:find(chatPrefixTest) then return true end
end)

addon:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)

addon:RegisterEvent("PLAYER_ENTERING_WORLD")
addon:RegisterEvent("CHAT_MSG_GUILD")
addon:RegisterEvent("CHAT_MSG_WHISPER")
--addon:RegisterEvent("CRAFT_SHOW")
--addon:RegisterEvent("TRADE_SKILL_SHOW")
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("CHAT_MSG_PARTY")
addon:RegisterEvent("CHAT_MSG_RAID")
addon:RegisterEvent("CHAT_MSG_OFFICER")
addon:RegisterEvent("CHAT_MSG_RAID_LEADER")


DEFAULT_CHAT_FRAME:AddMessage("WC loaded")